import { onPageLoadInitAuth, post } from '@/utils/https';
import { getAuthInfo, toArray } from '@/utils/util';

Page({
  /**
   * 页面的初始数据
   */
  data: {
    process_id: '',
    list: [] as any[],
    authInfo: {} as any,
  },
  handleLogin(e: any) {
    this.setData({ isLogin: e.detail });
    if (e.detail) {
      this.init();
      this.getList();
    }
  },
  init() {
    this.setData({ authInfo: getAuthInfo() });
  },
  getList() {
    return new Promise<void>((resolve, reject) => {
      post('CompanyProcessV2/getChildProcess', { process_id: this.data.process_id })
        .then((res: any) => {
          this.setData({ list: toArray(res.data), isLogin: true });
          resolve(res);
        })
        .catch((res) => {
          this.setData({ isLogin: false });
          reject(res);
        });
    });
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    const { process_id = '', title } = options || {};
    if (title) {
      wx.setNavigationBarTitle({ title: decodeURIComponent(title) });
    }
    this.data.process_id = process_id;
    onPageLoadInitAuth(this, () => this.getList());
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {},

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {},

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {},

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {},

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {},

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {},
});
